      PROGRAM GENROADMAP
      DOUBLE PRECISION box_x_min, box_x_max, box_y_min, box_y_max
      COMMON /box/ box_x_min, box_x_max, box_y_min, box_y_max
      
      INTEGER crc
      COMMON /buffer/ crc
      
      INTEGER WIDTH, HEIGHT
      COMMON /screen/ WIDTH, HEIGHT
      
      EXTERNAL FUNCTION sw_init, sw_start, sw_stop, sw_timeString

      CHARACTER buf*20

      WIDTH =500
      HEIGHT =500

      call sw_init();
      call sw_start();
      mynum = RoadMap()
      call sw_stop();
      call sw_timestring(buf)

      print *,'Time taken ',buf

      END
      
      INTEGER FUNCTION RoadMap ()
      INTEGER i
      INTEGER CreateMap
      INTEGER zooms, res
      
      DOUBLE PRECISION deltaxmin, deltaymin, deltaxmax,deltaymax;
      
      DOUBLE PRECISION mynum
      
      INTEGER crc
      COMMON /buffer/ crc

      INTEGER WIDTH, HEIGHT
      COMMON /screen/ WIDTH, HEIGHT

      DOUBLE PRECISION box_x_min, box_x_max, box_y_min, box_y_max
      COMMON /box/ box_x_min, box_x_max, box_y_min, box_y_max

      zooms=100
      
      box_x_min=-1.5
      box_x_max=0.5
      box_y_min=-1.0 
      box_y_max=1.0;
      
      deltaxmin=(-0.9-box_x_min)/zooms;
      deltaxmax=(-0.65-box_x_max)/zooms;
      deltaymin=(-0.4-box_y_min)/zooms;
      deltaymax=(-0.1-box_y_max)/zooms;
      
      call gs_init(WIDTH, HEIGHT)
      res=CreateMap()
      DO i=0,zooms
         box_x_min=box_x_min+deltaxmin;
         box_x_max=box_x_max+deltaxmax;
         box_y_min=box_y_min+deltaymin;
         box_y_max=box_y_max+deltaymax;
         res=CreateMap()
      END DO
      call gs_exit()
      RoadMap=0
      RETURN
      END
      
      
      
      INTEGER FUNCTION CreateMap()
      INTEGER crc
      COMMON /buffer/ crc
      INTEGER WIDTH, HEIGHT
      COMMON /screen/ WIDTH, HEIGHT
      INTEGER x,y,color  
      INTEGER, DIMENSION(11)::colortable
      EXTERNAL INTEGER FUNCTION gs_plot
      DOUBLE PRECISION translate_x, translate_y
      INTEGER solve
      INTEGER colorcount


      colortable(1)=Z'ffffff'
      colortable(2)=Z'ffffff'
      colortable(3)=Z'0000ff'
      colortable(4)=Z'7c8dff'
      colortable(5)=Z'000000'
      colortable(6)=Z'18ff08'
      colortable(7)=Z'ff00ff'
      colortable(8)=Z'ff8706'
      colortable(9)=Z'ff9a96'
      colortable(10)=Z'ff0000'
      colortable(11)=Z'ffff00'

      colorcount=10;

      yloop: DO y=0,HEIGHT-1
      xloop: DO x=0,WIDTH-1
      color=solve(translate_x(x),translate_y(y))*colorcount/100
      color=colortable(color+1)
      call gs_plot(x,y,color)
      END DO xloop
      END DO yloop
      CreateMap=0
      
      call gs_update()
      END

      INTEGER FUNCTION solve(x,y)
      DOUBLE PRECISION x,y
      DOUBLE PRECISION r,s
      DOUBLE PRECISION next_r,next_s
      INTEGER itt
      
      r=0.0
      s=0.0
      itt=0

      s_loop: DO WHILE ((r*r+s*s)<=4.0)
      next_r=r*r-s*s+x
      next_s=2*r*s+y
      r=next_r 
      s=next_s
      itt=itt+1
      IF(itt==100) THEN 
         EXIT s_loop
      END IF
      ENDDO s_loop
      solve=itt 
      RETURN
      END
      
      DOUBLE PRECISION FUNCTION translate_x(x)
      INTEGER x
      DOUBLE PRECISION box_x_min, box_x_max, box_y_min, box_y_max
      COMMON /box/ box_x_min, box_x_max, box_y_min, box_y_max
      INTEGER WIDTH, HEIGHT
      COMMON /screen/ WIDTH, HEIGHT
      
      translate_x = (((box_x_max-box_x_min)/WIDTH)*x)+box_x_min;
      RETURN
      END
      
      DOUBLE PRECISION FUNCTION translate_y(y)
      INTEGER y
      DOUBLE PRECISION box_x_min, box_x_max, box_y_min, box_y_max
      COMMON /box/ box_x_min, box_x_max, box_y_min, box_y_max
      INTEGER WIDTH, HEIGHT
      COMMON /screen/ WIDTH, HEIGHT
      
      translate_y = (((box_y_max-box_y_min)/HEIGHT)*y)+box_y_min
      RETURN
      END
      
      



